package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataInHarmVMapper;
import com.pqs9900.pojo.HisData.DataInHarmI;
import com.pqs9900.pojo.HisData.DataInHarmV;
import com.pqs9900.service.HisData.DataInHarmVService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO
 * @Date  2019/2/22 9:29
 **/
@Service
public class DataInHarmVServiceImpl implements DataInHarmVService {

    private static final Logger logger= LoggerFactory.getLogger(DataInHarmVServiceImpl.class);
    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Autowired
    private DataInHarmVMapper dataInHarmVMapper;
    @Override
    public int saveDataInHarmV(DataInHarmV dataInHarmV) {
        return dataInHarmVMapper.insert(dataInHarmV);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataInHarmV(List<DataInHarmV> list) {
        return dataInHarmVMapper.insertDataInHarmV(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataInHarmV 电压间谐波数据
     */
    @Override
    public Future insertDataInHarmVExecutor(List<DataInHarmV> listDataInHarmV) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataInHarmV.size() / (double) inum);
                    List<DataInHarmV> tmpListDataInHarmV = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataInHarmV.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataInHarmV.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataInHarmV.addAll(listDataInHarmV.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataInHarmVMapper.insertDataInHarmV(tmpListDataInHarmV);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("电压间谐波幅值表  导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
